.TH HG CLONE  "" "" ""
.SH NAME
hg clone \- make a copy of an existing repository
.\" Man page generated from reStructuredText.
.
.SH SYNOPSIS
.sp
.nf
.ft C
hg clone [OPTION]... SOURCE [DEST]
.ft P
.fi
.SH DESCRIPTION
.sp
Create a copy of an existing repository in a new directory.
.sp
If no destination directory name is specified, it defaults to the
basename of the source.
.sp
The location of the source is added to the new repository\(aqs
\fB.hg/hgrc\fP file, as the default to be used for future pulls.
.sp
Only local paths and \fBssh://\fP URLs are supported as
destinations. For \fBssh://\fP destinations, no working directory or
\fB.hg/hgrc\fP will be created on the remote side.
.sp
If the source repository has a bookmark called \(aq@\(aq set, that
revision will be checked out in the new repository by default.
.sp
To check out a particular version, use \-u/\-\-update, or
\-U/\-\-noupdate to create a clone with no working directory.
.sp
To pull only a subset of changesets, specify one or more revisions
identifiers with \-r/\-\-rev or branches with \-b/\-\-branch. The
resulting clone will contain only the specified changesets and
their ancestors. These options (or \(aqclone src#rev dest\(aq) imply
\-\-pull, even for local source repositories.
.sp
In normal clone mode, the remote normalizes repository data into a common
exchange format and the receiving end translates this data into its local
storage format. \-\-stream activates a different clone mode that essentially
copies repository files from the remote with minimal data processing. This
significantly reduces the CPU cost of a clone both remotely and locally.
However, it often increases the transferred data size by 30\-40%. This can
result in substantially faster clones where I/O throughput is plentiful,
especially for larger repositories. A side\-effect of \-\-stream clones is
that storage settings and requirements on the remote are applied locally:
a modern client may inherit legacy or inefficient storage used by the
remote or a legacy Mercurial client may not be able to clone from a
modern Mercurial remote.
.IP Note
.
Specifying a tag will include the tagged changeset but not the
changeset containing the tag.
.RE
.sp
For efficiency, hardlinks are used for cloning whenever the
source and destination are on the same filesystem (note this
applies only to the repository data, not to the working
directory). Some filesystems, such as AFS, implement hardlinking
incorrectly, but do not report errors. In these cases, use the
\-\-pull option to avoid hardlinking.
.sp
Mercurial will update the working directory to the first applicable
revision from this list:
.INDENT 0.0
.IP a. 3
.
null if \-U or the source repository has no changesets
.IP b. 3
.
if \-u . and the source repository is local, the first parent of
the source repository\(aqs working directory
.IP c. 3
.
the changeset specified with \-u (if a branch name, this means the
latest head of that branch)
.IP d. 3
.
the changeset specified with \-r
.IP e. 3
.
the tipmost head specified with \-b
.IP f. 3
.
the tipmost head specified with the url#branch source syntax
.IP g. 3
.
the revision marked with the \(aq@\(aq bookmark, if present
.IP h. 3
.
the tipmost head of the default branch
.IP i. 3
.
tip
.UNINDENT
.sp
When cloning from servers that support it, Mercurial may fetch
pre\-generated data from a server\-advertised URL or inline from the
same stream. When this is done, hooks operating on incoming changesets
and changegroups may fire more than once, once for each pre\-generated
bundle and as well as for any additional remaining data. In addition,
if an error occurs, the repository may be rolled back to a partial
clone. This behavior may change in future releases.
See \%\fBhg help \-e clonebundles\fP\: for more.
.sp
Examples:
.INDENT 0.0
.IP \(bu 2
.
clone a remote repository to a new directory named hg/:
.sp
.nf
.ft C
hg clone https://www.mercurial\-scm.org/repo/hg/
.ft P
.fi
.IP \(bu 2
.
create a lightweight local clone:
.sp
.nf
.ft C
hg clone project/ project\-feature/
.ft P
.fi
.IP \(bu 2
.
clone from an absolute path on an ssh server (note double\-slash):
.sp
.nf
.ft C
hg clone ssh://user@server//home/projects/alpha/
.ft P
.fi
.IP \(bu 2
.
do a streaming clone while checking out a specified version:
.sp
.nf
.ft C
hg clone \-\-stream http://server/repo \-u 1.5
.ft P
.fi
.IP \(bu 2
.
create a repository without changesets after a particular revision:
.sp
.nf
.ft C
hg clone \-r 04e544 experimental/ good/
.ft P
.fi
.IP \(bu 2
.
clone (and track) a particular named branch:
.sp
.nf
.ft C
hg clone https://www.mercurial\-scm.org/repo/hg/#stable
.ft P
.fi
.UNINDENT
.sp
See \%\fBhg help urls\fP\: for details on specifying URLs.
.sp
Returns 0 on success.
.SH OPTIONS
.INDENT 0.0
.TP
.B \-U,  \-\-noupdate
.
the clone will include an empty working directory (only a repository)
.TP
.BI \-u,  \-\-updaterev \ <REV>
.
revision, tag, or branch to check out
.TP
.BI \-r,  \-\-rev \ <REV[+]>
.
do not clone everything, but include this changeset and its ancestors
.TP
.BI \-b,  \-\-branch \ <BRANCH[+]>
.
do not clone everything, but include this branch\(aqs changesets and their ancestors
.TP
.B \-\-pull
.
use pull protocol to copy metadata
.TP
.B \-\-uncompressed
.
an alias to \-\-stream (DEPRECATED)
.TP
.B \-\-stream
.
clone with minimal data processing
.TP
.BI \-e,  \-\-ssh \ <CMD>
.
specify ssh command to use
.TP
.BI \-\-remotecmd \ <CMD>
.
specify hg command to run on the remote side
.TP
.B \-\-insecure
.
do not verify server certificate (ignoring web.cacerts config)
.UNINDENT
.sp
[+] marked option can be specified multiple times
.\" Generated by docutils manpage writer.
.\" 
.
